BEGIN { 
	j = 0
	i = 0
	totalstd = 0
	passed = 0
	grades = 0
}
NF == 6 {
#hold the students with the max grades
	if(max < ($4*(30/100)+$5*(30/100)+$6*(40/100))) {
		max = $4*(30/100)+$5*(30/100)+$6*(40/100)	
		maxstd[0] = $1
		maxgrade[0] = $4*(30/100)+$5*(30/100)+$6*(40/100)
		i = 0	
	} else if (max == ($4*(30/100)+$5*(30/100)+$6*(40/100))) {
		i = i + 1
		maxstd[i] = $1
		maxgrade[i] = $4*(30/100)+$5*(30/100)+$6*(40/100)
	}
#take the results
	for( x = 1 ; x <= 6 ; x++ )	result[j,x] = $x
#calculate the final grade in lecture	
	result[j,7]=$4*(30/100)+$5*(30/100)+$6*(40/100)
#hold the lenght for tabified output	
	for( x = 1 ; x <= 6 ; x++){
		if( maxlen[x] < length($x) ){
			maxlen[x]=length($x)		
		}	
	}	
	j++
#increase students in class
	totalstd++
#check if student pass and if so increase student who passed the lesson
	if(50 < ($4*(30/100)+$5*(30/100)+$6*(40/100))) passed++
	grades += $4*(30/100)+$5*(30/100)+$6*(40/100)
}
END {
#calculate the average grade
	mean = (grades / totalstd)
#calculate the percentage of failure
	failure = ((totalstd - passed)/totalstd)*100
#calculate the standard deviation	
	deviation = 0	
	for ( z = 0 ; z < j ; z++)
		deviation = deviation + ((result[z,7]-mean)*(result[z,7]-mean))
	deviation = deviation / totalstd
	deviation = sqrt(deviation)
#print section
#create .stat
	printf "#%s-%s-Computation of Static Data\n\n",lecture,semester > stat
	printf "Students in class: %d\nStudents passed:  %d\nFailure Percentage: %3.2f%%\nAverage Grade: %3.2f\nStandard Deviation: %3.2f\n",totalstd,passed,failure,mean,deviation >> stat
#if send mail flag is activated print to stdout the students who had the max grade	
	if(sm == 0) {
		for (x = 0; x <= i; x++) printf "%s ",maxstd[x]
	}
#cretae .final
	printf "#%s-%s-Computation of Final Grades\n\n",lecture,semester > final
	for ( i = 1 ; i <= 7 ; i++ ){
		if (i == 1) {
			printf "# UserID" >> final
			len = length("# UserID")
		} else if (i == 2) { 
			printf "FirstName" >> final
			len = length("FirstName")
		} else if (i == 3) { 
			printf "Lastname" >> final
			len = length("Lastname")
		} else if (i == 4) {
			printf "Exe1" >> final
			len = length("Exe1")
		} else if (i == 5) {
			printf "Exe2" >> final
			len = length("Exe2")
		} else if (i == 6) {
			printf "Exam" >> final
			len = length("Exam")
		} else if (i == 7) {
			printf "Final"	>> final
			len = length("Final")
		}
		if( i != 7) {
			if (maxlen[i] >= len ) {
				for(k = len ; k <= maxlen[i] + 2 ; k++) printf " " >> final
			} else {
				printf("   ") >>final
				maxlen[i] = len
			}
		} else		printf "\n" >> final
	}
	for ( i = 0 ; i < j ; i++) {
		for ( z = 1; z <= 6  ; z++){
			printf "%s",result[i,z]	>> final
			for(k = length(result[i,z]) ; k <= maxlen[z] + 2 ; k++) printf " " >> final
		}
		printf "%s\n",result[i,7] >> final
	}
	close(final)
	close(stat)
}
