#!/bin/bash
echo -e "\n\e[00;33mProceeding in cgi.di.uoa.gr server\e[00m\t[\e[00;31mDONE\e[00m]"
echo -ne "\n\e[00;33mData mining from di.uoa.gr server.(This might take some time....)\e[00m\t"
ls -l /home/users | awk ' $9 ~ /^std/ { print $9 } ' > users.txt
exec < users.txt
while read l
	do
		if [[ "$(uname)" = "Linux" ]] ; then		
			finger -m $l | head -1 | nawk -v li=$l ' { print li,$4,$5,rand()*100 ,rand()*100,rand()*100} ' >> K0
		elif [[ "$(uname)" = "SunOS" ]] ; then
			finger -m $l | head -1 | nawk -v li=$l ' { print li,$7,$8,rand ( ) *100 ,rand ( ) *100,rand ( ) *100} ' >> K0
		else
			echo "Unknown Operating System"
			exit
		fi
	done
rm -rf users.txt
echo -e "[\e[00;31mDONE\e[00m]"
echo -e "\n\e[00;31mCreating\e[00m directory \e[00;33mGRADES\e[00m"
mkdir GRADES
cd GRADES
for((i=0;i<=99;i++))
	do
		j=$i
		if [ "$j" -lt 10 ] 
		 then 
			if [[ "$(uname)" = "Linux" ]] ; then 
					export len=`expr length $j` 
				else 
					export len=`echo ${#j}`
				fi
		 	if [ $len -eq 1 ] 
			 then 
				export j=`echo 0$j` 
			 fi 
		 fi
		export f=`echo fall$j`
		export s=`echo spring$j`
		mkdir $f
		mkdir $s
		echo -e "\t \e[00;33mCreating\e[00m \e[00;36m$f\e[00m"
		cd $f
		for((k=1;k<=28;k++))
			do
				j=$k
				if [ "$j" -lt 10 ] 
		 			then 
					if [[ "$(uname)" = "Linux" ]] ; then 
						export len=`expr length $j` 
					else 
						export len=`echo ${#j}`
					fi 
		 			if [ $len -eq 1 ] 
					 then 
						export j=`echo 0$j` 
					 fi 
				fi
				mkdir "K0$j"
				cd "K0$j"
				cat ../../../K0 | head -5 > "K0$j.input"
				cd ..			
			done		
		cd ..
		echo -e "\t \e[00;33mCreating\e[00m \e[00;36m$s\e[00m"
		cd $s
		for((k=1;k<=28;k++))
			do
				j=$k
				if [ "$j" -lt 10 ] 
		 			then 
					if [[ "$(uname)" = "Linux" ]] ; then 
						export len=`expr length $j` 
					else 
						export len=`echo ${#j}`
					fi 
		 			if [ $len -eq 1 ] 
					 then 
						export j=`echo 0$j` 
					 fi 
				 fi
				mkdir "K0$j"
				cd "K0$j"
				cat ../../../K0 | tail -5 > "K0$j.input"
				cd ..
			done		
		cd ..
	done
cd ..
echo -e "[\e[00;31mDONE\e[00m]"
rm -rf K0
unalias ls

